#vider la mmoire
rm(list=ls())

#charger la bibliothque rpart
library(rpart)

#charger les donnes
setwd("D:/DataMining/Databases_for_mining/comparison_TOW/validation_croisee")
donnees <- read.table(file="heart.txt",dec=".",header=TRUE)
summary(donnees)

#construire et imprimer l'arbre calcul sur la totalit des individus
arbre.full <- rpart(coeur ~ ., data = donnees, method = "class")
print(arbre.full)
#matrice de confusion et erreur en resubstitution
pred <- predict(arbre.full, newdata = donnees, type = "class")
mc <- table(donnees$coeur,pred) #matrice de confusion
print(mc)
err.resub <- 1.0 - (mc[1,1]+mc[2,2])/sum(mc)
print(err.resub)

#dterminer le numro de bloc de chaque individu
n <- nrow(donnees) #nombre d'observations
K <- 10 # pour 10-validation croise
taille <- n%/%K #dterminer la taille de chaque bloc
set.seed(5) #pour obtenir la mme squence tout le temps
alea <- runif(n) #gnrer une colonne de valeurs alatoires
rang <- rank(alea) #associer  chaque individu un rang
bloc <- (rang-1)%/%taille + 1 # associer  chaque individu un numro de bloc
bloc <- as.factor(bloc) #transformer en factor
print(summary(bloc)) #impression de contrle

#lancer la validation croise
all.err <- numeric(0)
for (k in 1:K){
  #apprendre le modle sur tous les individus sauf le bloc k
  arbre <- rpart(coeur ~., data = donnees[bloc!=k,], method = "class")
  #appliquer le modle sur le bloc numro k
  pred <- predict(arbre,newdata=donnees[bloc==k,], type = "class")
  #matrice de confusion
  mc <- table(donnees$coeur[bloc==k],pred)
  #taux d'erreur
  err <- 1.0 - (mc[1,1]+mc[2,2])/sum(mc)
  #conserver
  all.err <- rbind(all.err,err)
}

#vecteur des erreurs recueillies
print(all.err)

#erreur en validation croise
#on peut se contenter d'une moyenne non pondre puisque les blocs sont
#de taille identique
err.cv <- mean(all.err)
print(err.cv)



